'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _types = require('./types');

var _reactabularUtils = require('reactabular-utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// This has to be a React component instead of a function.
// Otherwise refs won't work.
var Header = function (_React$Component) {
  _inherits(Header, _React$Component);

  function Header() {
    _classCallCheck(this, Header);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(Header).apply(this, arguments));
  }

  _createClass(Header, [{
    key: 'render',
    // eslint-disable-line max-len, react/prefer-stateless-function
    value: function render() {
      var _props = this.props;
      var children = _props.children;

      var props = _objectWithoutProperties(_props, ['children']);

      var _context = this.context;
      var headerColumns = _context.headerColumns;
      var components = _context.components;


      return _react2.default.createElement(components.header.wrapper, props, [(0, _reactabularUtils.resolveHeaderRows)(headerColumns).map(function (row, i) {
        return _react2.default.createElement(HeaderRow, {
          key: i + '-header-row',
          components: components.header,
          row: row
        });
      })].concat(children));
    }
  }]);

  return Header;
}(_react2.default.Component);

exports.default = Header;

Header.propTypes = {
  children: _react2.default.PropTypes.any
};
Header.contextTypes = _types.tableHeaderContextTypes;

var HeaderRow = function HeaderRow(_ref) {
  var row = _ref.row;
  var components = _ref.components;
  return _react2.default.createElement(components.row, {}, row.map(function (_ref2, j) {
    var column = _ref2.column;
    var _ref2$header = _ref2.header;
    var header = _ref2$header === undefined ? {} : _ref2$header;
    var _ref2$props = _ref2.props;
    var props = _ref2$props === undefined ? {} : _ref2$props;
    var label = header.label;
    var _header$transforms = header.transforms;
    var transforms = _header$transforms === undefined ? [] : _header$transforms;
    var _header$format = header.format;
    var format = _header$format === undefined ? function (a) {
      return a;
    } : _header$format;

    var extraParameters = {
      columnIndex: j,
      column: column
    };
    var transformedProps = (0, _reactabularUtils.evaluateTransforms)(transforms, label, extraParameters);

    if (!transformedProps) {
      console.warn('Table.Header - Failed to receive a transformed result'); // eslint-disable-line max-len, no-console
    }

    return _react2.default.createElement(components.cell, _extends({
      key: j + '-header'
    }, (0, _reactabularUtils.mergePropPair)(props, transformedProps)), transformedProps.children || format(label, extraParameters));
  }));
};
HeaderRow.propTypes = {
  row: _react2.default.PropTypes.arrayOf(_react2.default.PropTypes.object),
  components: _react2.default.PropTypes.object
};