'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.tableDefaults = exports.tableHeaderContextTypes = exports.tableBodyContextTypes = exports.tableBodyTypes = exports.tableContextTypes = exports.tableTypes = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var arrayOfObjectColumns = _react2.default.PropTypes.arrayOf(_react2.default.PropTypes.shape({
  header: _react2.default.PropTypes.shape({
    label: _react2.default.PropTypes.string,
    transforms: _react2.default.PropTypes.arrayOf(_react2.default.PropTypes.func),
    format: _react2.default.PropTypes.func,
    component: _react2.default.PropTypes.any, // XXX: too loose? createElement first param
    props: _react2.default.PropTypes.object
  }),
  cell: _react2.default.PropTypes.shape({
    property: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.number, _react2.default.PropTypes.string]),
    transforms: _react2.default.PropTypes.arrayOf(_react2.default.PropTypes.func),
    format: _react2.default.PropTypes.func,
    component: _react2.default.PropTypes.any, // XXX: too loose? createElement first param
    props: _react2.default.PropTypes.object
  })
}));
var arrayOfArrayColumns = _react2.default.PropTypes.arrayOf(_react2.default.PropTypes.array);
var rowKeyType = function rowKeyType(props, propName, componentName) {
  if (props.data && props.data.length && !arrayOfObjectColumns(props, 'data', componentName)) {
    return _react2.default.PropTypes.string.isRequired(props, propName, componentName);
  }

  // `columns` should be an array of arrays. If it's not, then that propType will
  // fail even if this doesn't.
  return null;
};
var rowsType = _react2.default.PropTypes.oneOfType([arrayOfObjectColumns, arrayOfArrayColumns]);
var tableTypes = {
  columns: _react2.default.PropTypes.array.isRequired,
  components: _react2.default.PropTypes.object
};
var tableContextTypes = {
  headerColumns: _react2.default.PropTypes.array.isRequired,
  bodyColumns: _react2.default.PropTypes.array.isRequired,
  components: _react2.default.PropTypes.object
};
var tableBodyTypes = {
  onRow: _react2.default.PropTypes.func,
  rows: rowsType.isRequired,
  rowKey: rowKeyType
};
var tableBodyContextTypes = {
  bodyColumns: _react2.default.PropTypes.array.isRequired,
  components: _react2.default.PropTypes.object
};
var tableHeaderContextTypes = {
  headerColumns: _react2.default.PropTypes.array.isRequired,
  components: _react2.default.PropTypes.object
};
var tableDefaults = {
  components: {
    table: 'table',
    header: {
      wrapper: 'thead',
      row: 'tr',
      cell: 'th'
    },
    body: {
      wrapper: 'tbody',
      row: 'tr',
      cell: 'td'
    }
  }
};

exports.tableTypes = tableTypes;
exports.tableContextTypes = tableContextTypes;
exports.tableBodyTypes = tableBodyTypes;
exports.tableBodyContextTypes = tableBodyContextTypes;
exports.tableHeaderContextTypes = tableHeaderContextTypes;
exports.tableDefaults = tableDefaults;